<template>
  <div class="min-h-screen relative">
    <!-- Globe View -->
    <div class="absolute inset-0 flex items-start pt-24 justify-center">
      <GlobeView 
        @cdm-selected="updateSelectedCDM" 
        @drm-selected="updateSelectedDRM"
        :latestActivities="latestActivities" 
      />
    </div>

    <!-- Instrument Panel -->
    <InstrumentPanel position="left" class="z-50" />

    <!-- CDM Details Panel -->
    <Transition name="slide-up">
      <CDMDetailsPanel 
        v-if="selectedCDM && globeMode === 'CDM'"
        :selectedDataPoint="selectedCDM"
        class="fixed right-4 bottom-24 z-[100]" 
      />
    </Transition>

    <!-- DRM Details Panel -->
    <Transition name="slide-up">
      <DRMDetailsPanel 
        v-if="selectedDRM && globeMode === 'DRM'"
        :selectedDataPoint="selectedDRM"
        class="fixed right-4 bottom-24 z-[100]" 
      />
    </Transition>
  </div>
</template>

<script setup lang="ts">
import { ref, onMounted, inject } from 'vue'
import GlobeView from '@/components/HomeContent/GlobeCDMView.vue'
import InstrumentPanel from '@/components/Panels/InstrumentPanel.vue'
import CDMDetailsPanel from '@/components/Panels/CDMDetailsPanel.vue'
import DRMDetailsPanel from '@/components/Panels/DRMDetailsPanel.vue'
import type { CDMData } from '@/types/cdm'
import type { DRMData } from '@/types/drm'
import type { LatestActivities } from '@/types/types'

const globeMode = inject('globeMode') as { value: string }
const selectedCDM = ref<CDMData | null>(null)
const selectedDRM = ref<DRMData | null>(null)
const latestActivities = ref<LatestActivities>({
  spatialData: '0',
  collisionData: 0,
  satellitesData: 0
})

const updateSelectedCDM = (cdm: CDMData | null) => {
  selectedCDM.value = cdm
  selectedDRM.value = null
}

const updateSelectedDRM = (drm: DRMData | null) => {
  selectedDRM.value = drm
  selectedCDM.value = null
}

const refreshData = () => {
  latestActivities.value = {
    spatialData: `${Math.floor(Math.random() * 60)}`,
    collisionData: Math.floor(Math.random() * 10),
    satellitesData: Math.floor(Math.random() * 100)
  }
}

onMounted(() => {
  // Initial data refresh
  refreshData()
  // Set up interval for periodic updates
  setInterval(refreshData, 60000) // Update every minute
})
</script>

<style scoped>
.min-h-screen {
  min-height: 100vh;
  font-family: 'Ubuntu', sans-serif;
}

.slide-up-enter-active,
.slide-up-leave-active {
  transition: all 0.3s ease-out;
}

.slide-up-enter-from {
  transform: translateY(20px);
  opacity: 0;
}

.slide-up-leave-to {
  transform: translateY(20px);
  opacity: 0;
}
</style>
